diff --git a/gcc/config/lm32/lm32.h b/gcc/config/lm32/lm32.h
index e4db519..b253884 100644
--- a/gcc/config/lm32/lm32.h
+++ b/gcc/config/lm32/lm32.h
@@ -374,9 +374,9 @@ enum reg_class
 /* PIC.  */
 /*-------*/
 
-#define PIC_OFFSET_TABLE_REGNUM (flag_pic ? GP_REGNUM : INVALID_REGNUM)
+#define PIC_OFFSET_TABLE_REGNUM (GCC_OPTION (flag_pic) ? GP_REGNUM : INVALID_REGNUM)
 
-#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)
+#define JUMP_TABLES_IN_TEXT_SECTION (GCC_OPTION (flag_pic))
 
 #define LEGITIMATE_PIC_OPERAND_P(X)                                    \
 	(!(nonpic_symbol_mentioned_p (X)))
@@ -404,12 +404,12 @@ enum reg_class
 #undef  ASM_OUTPUT_ALIGNED_LOCAL
 #define ASM_OUTPUT_ALIGNED_LOCAL(FILE, NAME, SIZE, ALIGN)		\
 do {									\
-  if ((SIZE) <= (unsigned HOST_WIDE_INT) g_switch_value)		\
+  if ((SIZE) <= (unsigned HOST_WIDE_INT) GCC_OPTION (g_switch_value))		\
     switch_to_section (sbss_section);					\
   else									\
     switch_to_section (bss_section);					\
   ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");			\
-  if (!flag_inhibit_size_directive)					\
+  if (!GCC_OPTION (flag_inhibit_size_directive))					\
     ASM_OUTPUT_SIZE_DIRECTIVE (FILE, NAME, SIZE);			\
   ASM_OUTPUT_ALIGN ((FILE), exact_log2((ALIGN) / BITS_PER_UNIT));	\
   ASM_OUTPUT_LABEL(FILE, NAME);						\
@@ -421,12 +421,12 @@ do {									\
 #define ASM_OUTPUT_ALIGNED_COMMON(FILE, NAME, SIZE, ALIGN)		\
 do 									\
 {									\
-  if ((SIZE) <= (unsigned HOST_WIDE_INT) g_switch_value)		\
+  if ((SIZE) <= (unsigned HOST_WIDE_INT) GCC_OPTION (g_switch_value))		\
     {									\
       switch_to_section (sbss_section);					\
       (*targetm.asm_out.globalize_label) (FILE, NAME);			\
       ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");			\
-      if (!flag_inhibit_size_directive)					\
+      if (!GCC_OPTION (flag_inhibit_size_directive))					\
 	ASM_OUTPUT_SIZE_DIRECTIVE (FILE, NAME, SIZE);			\
       ASM_OUTPUT_ALIGN ((FILE), exact_log2((ALIGN) / BITS_PER_UNIT));	\
       ASM_OUTPUT_LABEL(FILE, NAME);					\
diff --git a/gcc/config/m32c/m32c.c b/gcc/config/m32c/m32c.c
index 57cfb20..9e7ebb6 100644
--- a/gcc/config/m32c/m32c.c
+++ b/gcc/config/m32c/m32c.c
@@ -427,21 +427,21 @@ m32c_option_override (void)
     target_memregs = 16;
 
   if (TARGET_A24)
-    flag_ivopts = 0;
+    GCC_OPTION (flag_ivopts) = 0;
 
   /* This target defaults to strict volatile bitfields.  */
-  if (flag_strict_volatile_bitfields < 0 && abi_version_at_least(2))
-    flag_strict_volatile_bitfields = 1;
+  if (GCC_OPTION (flag_strict_volatile_bitfields) < 0 && abi_version_at_least(2))
+    GCC_OPTION (flag_strict_volatile_bitfields) = 1;
 
   /* r8c/m16c have no 16-bit indirect call, so thunks are involved.
      This is always worse than an absolute call.  */
   if (TARGET_A16)
-    flag_no_function_cse = 1;
+    GCC_OPTION (flag_no_function_cse) = 1;
 
   /* This wants to put insns between compares and their jumps.  */
   /* FIXME: The right solution is to properly trace the flags register
      values, but that is too much work for stage 4.  */
-  flag_combine_stack_adjustments = 0;
+  GCC_OPTION (flag_combine_stack_adjustments) = 0;
 }
 
 #undef TARGET_OVERRIDE_OPTIONS_AFTER_CHANGE
@@ -451,7 +451,7 @@ static void
 m32c_override_options_after_change (void)
 {
   if (TARGET_A16)
-    flag_no_function_cse = 1;
+    GCC_OPTION (flag_no_function_cse) = 1;
 }
 
 /* Defining data structures for per-function information */
diff --git a/gcc/config/m32c/m32c.h b/gcc/config/m32c/m32c.h
index 94865ce..29b8125 100644
--- a/gcc/config/m32c/m32c.h
+++ b/gcc/config/m32c/m32c.h
@@ -89,10 +89,10 @@ extern int ok_to_change_target_memregs;
 /* TARGET_CPU is a multi-way option set in m32c.opt.  While we could
    use enums or defines for this, this and m32c.opt are the only
    places that know (or care) what values are being used.  */
-#define TARGET_R8C	(target_cpu == 'r')
-#define TARGET_M16C	(target_cpu == '6')
-#define TARGET_M32CM	(target_cpu == 'm')
-#define TARGET_M32C	(target_cpu == '3')
+#define TARGET_R8C	(GCC_OPTION (target_cpu) == 'r')
+#define TARGET_M16C	(GCC_OPTION (target_cpu) == '6')
+#define TARGET_M32CM	(GCC_OPTION (target_cpu) == 'm')
+#define TARGET_M32C	(GCC_OPTION (target_cpu) == '3')
 
 /* Address register sizes.  Warning: these are used all over the place
    to select between the two CPU families in general.  */
diff --git a/gcc/config/m32r/m32r-opts.h b/gcc/config/m32r/m32r-opts.h
index db9886f..90be480 100644
--- a/gcc/config/m32r/m32r-opts.h
+++ b/gcc/config/m32r/m32r-opts.h
@@ -43,13 +43,13 @@
 
 enum m32r_model { M32R_MODEL_SMALL, M32R_MODEL_MEDIUM, M32R_MODEL_LARGE };
 
-#define TARGET_MODEL_SMALL  (m32r_model_selected == M32R_MODEL_SMALL)
-#define TARGET_MODEL_MEDIUM (m32r_model_selected == M32R_MODEL_MEDIUM)
-#define TARGET_MODEL_LARGE  (m32r_model_selected == M32R_MODEL_LARGE)
-#define TARGET_ADDR24       (m32r_model_selected == M32R_MODEL_SMALL)
+#define TARGET_MODEL_SMALL  (GCC_OPTION (m32r_model_selected) == M32R_MODEL_SMALL)
+#define TARGET_MODEL_MEDIUM (GCC_OPTION (m32r_model_selected) == M32R_MODEL_MEDIUM)
+#define TARGET_MODEL_LARGE  (GCC_OPTION (m32r_model_selected) == M32R_MODEL_LARGE)
+#define TARGET_ADDR24       (GCC_OPTION (m32r_model_selected) == M32R_MODEL_SMALL)
 #define TARGET_ADDR32       (! TARGET_ADDR24)
 #define TARGET_CALL26       (! TARGET_CALL32)
-#define TARGET_CALL32       (m32r_model_selected == M32R_MODEL_LARGE)
+#define TARGET_CALL32       (GCC_OPTION (m32r_model_selected) == M32R_MODEL_LARGE)
 
 /* The default is the small model.  */
 #ifndef M32R_MODEL_DEFAULT
@@ -95,9 +95,9 @@ enum m32r_model { M32R_MODEL_SMALL, M32R_MODEL_MEDIUM, M32R_MODEL_LARGE };
 
 enum m32r_sdata { M32R_SDATA_NONE, M32R_SDATA_SDATA, M32R_SDATA_USE };
 
-#define TARGET_SDATA_NONE  (m32r_sdata_selected == M32R_SDATA_NONE)
-#define TARGET_SDATA_SDATA (m32r_sdata_selected == M32R_SDATA_SDATA)
-#define TARGET_SDATA_USE   (m32r_sdata_selected == M32R_SDATA_USE)
+#define TARGET_SDATA_NONE  (GCC_OPTION (m32r_sdata_selected) == M32R_SDATA_NONE)
+#define TARGET_SDATA_SDATA (GCC_OPTION (m32r_sdata_selected) == M32R_SDATA_SDATA)
+#define TARGET_SDATA_USE   (GCC_OPTION (m32r_sdata_selected) == M32R_SDATA_USE)
 
 /* Default is to disable the SDA
    [for upward compatibility with previous toolchains].  */
diff --git a/gcc/config/m32r/m32r.c b/gcc/config/m32r/m32r.c
index 83bc3a7..da35899 100644
--- a/gcc/config/m32r/m32r.c
+++ b/gcc/config/m32r/m32r.c
@@ -219,7 +219,7 @@ m32r_init (void)
 
   /* Provide default value if not specified.  */
   if (!global_options_set.x_g_switch_value)
-    g_switch_value = SDATA_DEFAULT_SIZE;
+    GCC_OPTION (g_switch_value) = SDATA_DEFAULT_SIZE;
 }
 
 static void
@@ -481,7 +481,7 @@ m32r_in_small_data_p (const_tree decl)
 	{
 	  int size = int_size_in_bytes (TREE_TYPE (decl));
 
-	  if (size > 0 && size <= g_switch_value)
+	  if (size > 0 && size <= GCC_OPTION (g_switch_value))
 	    return true;
 	}
     }
@@ -534,7 +534,7 @@ addr24_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
 {
   rtx sym;
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     return 0;
 
   if (GET_CODE (op) == LABEL_REF)
@@ -577,7 +577,7 @@ addr32_operand (rtx op, enum machine_mode mode)
 	   && GET_CODE (XEXP (op, 0)) == PLUS
 	   && GET_CODE (XEXP (XEXP (op, 0), 0)) == SYMBOL_REF
 	   && CONST_INT_P (XEXP (XEXP (op, 0), 1))
-	   && ! flag_pic)
+	   && ! GCC_OPTION (flag_pic))
     sym = XEXP (XEXP (op, 0), 0);
   else
     return 0;
@@ -591,7 +591,7 @@ addr32_operand (rtx op, enum machine_mode mode)
 int
 call26_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     return 1;
 
   if (GET_CODE (op) == SYMBOL_REF)
@@ -1540,7 +1540,7 @@ m32r_compute_frame_size (int size)	/* # of var. bytes allocated.  */
   unsigned int gmask;
   enum m32r_function_type fn_type;
   int interrupt_p;
-  int pic_reg_used = flag_pic && (crtl->uses_pic_offset_table
+  int pic_reg_used = GCC_OPTION (flag_pic) && (crtl->uses_pic_offset_table
                                   | crtl->profile);
 
   var_size	= M32R_STACK_ALIGN (size);
@@ -1651,7 +1651,7 @@ m32r_expand_prologue (void)
   int regno;
   int frame_size;
   unsigned int gmask;
-  int pic_reg_used = flag_pic && (crtl->uses_pic_offset_table
+  int pic_reg_used = GCC_OPTION (flag_pic) && (crtl->uses_pic_offset_table
                                   | crtl->profile);
 
   if (! current_frame_info.initialized)
@@ -1799,7 +1799,7 @@ m32r_expand_epilogue (void)
       unsigned int gmask = current_frame_info.gmask;
       int can_trust_sp_p = !cfun->calls_alloca;
 
-      if (flag_exceptions)
+      if (GCC_OPTION (flag_exceptions))
         emit_insn (gen_blockage ());
 
       /* The first thing to do is point the sp at the bottom of the register
@@ -2004,7 +2004,7 @@ static rtx
 m32r_legitimize_address (rtx x, rtx orig_x ATTRIBUTE_UNUSED,
 			 enum machine_mode mode ATTRIBUTE_UNUSED)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     return m32r_legitimize_pic_address (x, NULL_RTX);
   else
     return x;
@@ -2039,10 +2039,10 @@ m32r_file_start (void)
 {
   default_file_start ();
 
-  if (flag_verbose_asm)
+  if (GCC_OPTION (flag_verbose_asm))
     fprintf (asm_out_file,
 	     "%s M32R/D special options: -G %d\n",
-	     ASM_COMMENT_START, g_switch_value);
+	     ASM_COMMENT_START, GCC_OPTION (g_switch_value));
 
   if (TARGET_LITTLE_ENDIAN)
     fprintf (asm_out_file, "\t.little\n");
@@ -2525,7 +2525,7 @@ m32r_expand_block_move (rtx operands[])
   /* If we prefer size over speed, always use a function call.
      If we do not know the size, use a function call.
      If the blocks are not word aligned, use a function call.  */
-  if (optimize_size || ! constp || align != UNITS_PER_WORD)
+  if (GCC_OPTION (optimize_size) || ! constp || align != UNITS_PER_WORD)
     {
       block_move_call (dst_reg, src_reg, bytes_rtx);
       return 0;
@@ -2780,12 +2780,12 @@ m32r_trampoline_init (rtx m_tramp, tree fndecl, rtx chain_value)
   emit_move_insn (adjust_address (m_tramp, SImode, 20),
 		  XEXP (DECL_RTL (fndecl), 0));
 
-  if (m32r_cache_flush_trap >= 0)
+  if (GCC_OPTION (m32r_cache_flush_trap) >= 0)
     emit_insn (gen_flush_icache
 	       (validize_mem (adjust_address (m_tramp, SImode, 0)),
-		gen_int_mode (m32r_cache_flush_trap, SImode)));
-  else if (m32r_cache_flush_func && m32r_cache_flush_func[0])
-    emit_library_call (m32r_function_symbol (m32r_cache_flush_func),
+		gen_int_mode (GCC_OPTION (m32r_cache_flush_trap), SImode)));
+  else if (GCC_OPTION (m32r_cache_flush_func) && GCC_OPTION (m32r_cache_flush_func)[0])
+    emit_library_call (m32r_function_symbol (GCC_OPTION (m32r_cache_flush_func)),
 		       LCT_NORMAL, VOIDmode, 3, XEXP (m_tramp, 0), Pmode,
 		       gen_int_mode (TRAMPOLINE_SIZE, SImode), SImode,
 		       GEN_INT (3), SImode);
@@ -2895,7 +2895,7 @@ m32r_legitimate_address_p (enum machine_mode mode, rtx x, bool strict)
 static void
 m32r_conditional_register_usage (void)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       fixed_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
       call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
diff --git a/gcc/config/m32r/m32r.h b/gcc/config/m32r/m32r.h
index 4851379..61e8f19 100644
--- a/gcc/config/m32r/m32r.h
+++ b/gcc/config/m32r/m32r.h
@@ -678,7 +678,7 @@ extern enum reg_class m32r_regno_reg_class[FIRST_PSEUDO_REGISTER];
 #define FUNCTION_PROFILER(FILE, LABELNO)			\
   do								\
     {								\
-      if (flag_pic)						\
+      if (GCC_OPTION (flag_pic))						\
 	{							\
 	  fprintf (FILE, "\tld24 r14,#mcount\n");		\
 	  fprintf (FILE, "\tadd r14,r12\n");			\
@@ -743,7 +743,7 @@ L2:     .word STATIC
    ||  GET_CODE (X) == SYMBOL_REF \
    ||  CONST_INT_P (X)  \
    || (GET_CODE (X) == CONST      \
-       && ! (flag_pic && ! m32r_legitimate_pic_operand_p (X))))
+       && ! (GCC_OPTION (flag_pic) && ! m32r_legitimate_pic_operand_p (X))))
 
 /* Condition code usage.  */
 
@@ -779,7 +779,7 @@ L2:     .word STATIC
    output in the text section, along with the assembler instructions.
    Otherwise, the readonly data section is used.
    This macro is irrelevant if there is no separate readonly data section.  */
-#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)
+#define JUMP_TABLES_IN_TEXT_SECTION (GCC_OPTION (flag_pic))
 
 /* Position Independent Code.  */
 
@@ -928,9 +928,9 @@ L2:     .word STATIC
 
    Loop unrolling currently doesn't like this optimization, so
    disable doing if we are unrolling loops and saving space.  */
-#define LOOP_TEST_THRESHOLD (optimize_size				\
-			     && !flag_unroll_loops			\
-			     && !flag_unroll_all_loops ? 2 : 30)
+#define LOOP_TEST_THRESHOLD (GCC_OPTION (optimize_size)				\
+			     && !GCC_OPTION (flag_unroll_loops)			\
+			     && !GCC_OPTION (flag_unroll_all_loops) ? 2 : 30)
 
 /* This is how to output an assembler line
    that says to advance the location counter
@@ -958,7 +958,7 @@ L2:     .word STATIC
     {									\
       if (! TARGET_SDATA_NONE						\
 	  && (SIZE) > 0							\
-	  && (SIZE) <= (unsigned HOST_WIDE_INT) g_switch_value)		\
+	  && (SIZE) <= (unsigned HOST_WIDE_INT) GCC_OPTION (g_switch_value))		\
 	fprintf ((FILE), "%s", SCOMMON_ASM_OP);				\
       else								\
 	fprintf ((FILE), "%s", COMMON_ASM_OP);				\
@@ -972,7 +972,7 @@ L2:     .word STATIC
     {									\
       if (! TARGET_SDATA_NONE						\
           && (SIZE) > 0							\
-	  && (SIZE) <= (unsigned HOST_WIDE_INT) g_switch_value)		\
+	  && (SIZE) <= (unsigned HOST_WIDE_INT) GCC_OPTION (g_switch_value))		\
         switch_to_section (get_named_section (NULL, ".sbss", 0));	\
       else								\
         switch_to_section (bss_section);				\
@@ -1000,7 +1000,7 @@ L2:     .word STATIC
 
 /* Specify the machine mode that this machine uses
    for the index in the tablejump instruction.  */
-#define CASE_VECTOR_MODE (flag_pic ? SImode : Pmode)
+#define CASE_VECTOR_MODE (GCC_OPTION (flag_pic) ? SImode : Pmode)
 
 /* Define if operations between registers always perform the operation
    on the full register even if a narrower mode is specified.  */
diff --git a/gcc/config/m68k/linux.h b/gcc/config/m68k/linux.h
index 5a586f5..5062d56 100644
--- a/gcc/config/m68k/linux.h
+++ b/gcc/config/m68k/linux.h
@@ -133,7 +133,7 @@ along with GCC; see the file COPYING3.  If not see
 #undef FUNCTION_PROFILER
 #define FUNCTION_PROFILER(FILE, LABELNO) \
 {									\
-  if (flag_pic)								\
+  if (GCC_OPTION (flag_pic))								\
     fprintf (FILE, "\tbsr.l _mcount@PLTPC\n");				\
   else									\
     fprintf (FILE, "\tjbsr _mcount\n");					\
diff --git a/gcc/config/m68k/m68k.c b/gcc/config/m68k/m68k.c
index 7f7d668..720b05a 100644
--- a/gcc/config/m68k/m68k.c
+++ b/gcc/config/m68k/m68k.c
@@ -449,13 +449,13 @@ m68k_option_override (void)
   unsigned long target_mask;
 
   if (global_options_set.x_m68k_arch_option)
-    m68k_arch_entry = &all_isas[m68k_arch_option];
+    m68k_arch_entry = &all_isas[GCC_OPTION (m68k_arch_option)];
 
   if (global_options_set.x_m68k_cpu_option)
-    m68k_cpu_entry = &all_devices[(int) m68k_cpu_option];
+    m68k_cpu_entry = &all_devices[(int) GCC_OPTION (m68k_cpu_option)];
 
   if (global_options_set.x_m68k_tune_option)
-    m68k_tune_entry = &all_microarchs[(int) m68k_tune_option];
+    m68k_tune_entry = &all_microarchs[(int) GCC_OPTION (m68k_tune_option)];
 
   /* User can choose:
 
@@ -503,7 +503,7 @@ m68k_option_override (void)
     target_mask |= MASK_CF_HWDIV;
   if ((m68k_cpu_flags & (FL_68881 | FL_CF_FPU)) != 0)
     target_mask |= MASK_HARD_FLOAT;
-  target_flags |= target_mask & ~target_flags_explicit;
+  GCC_OPTION (target_flags) |= target_mask & ~target_flags_explicit;
 
   /* Set the directly-usable versions of the -mcpu and -mtune settings.  */
   m68k_cpu = entry->device;
@@ -542,20 +542,20 @@ m68k_option_override (void)
    * -fpic but it hasn't been tested properly.
    */
   if (TARGET_SEP_DATA || TARGET_ID_SHARED_LIBRARY)
-    flag_pic = 2;
+    GCC_OPTION (flag_pic) = 2;
 
   /* -mpcrel -fPIC uses 32-bit pc-relative displacements.  Raise an
      error if the target does not support them.  */
-  if (TARGET_PCREL && !TARGET_68020 && flag_pic == 2)
+  if (TARGET_PCREL && !TARGET_68020 && GCC_OPTION (flag_pic) == 2)
     error ("-mpcrel -fPIC is not currently supported on selected cpu");
 
   /* ??? A historic way of turning on pic, or is this intended to
      be an embedded thing that doesn't have the same name binding
      significance that it does on hosted ELF systems?  */
-  if (TARGET_PCREL && flag_pic == 0)
-    flag_pic = 1;
+  if (TARGET_PCREL && GCC_OPTION (flag_pic) == 0)
+    GCC_OPTION (flag_pic) = 1;
 
-  if (!flag_pic)
+  if (!GCC_OPTION (flag_pic))
     {
       m68k_symbolic_call_var = M68K_SYMBOLIC_CALL_JSR;
 
@@ -581,7 +581,7 @@ m68k_option_override (void)
 	 function call to be done as `bsr foo@PLTPC'.  */
       /* ??? It's traditional to do this for -mpcrel too, but it isn't
 	 clear how intentional that is.  */
-      flag_no_function_cse = 1;
+      GCC_OPTION (flag_no_function_cse) = 1;
     }
 
   switch (m68k_symbolic_call_var)
@@ -607,15 +607,15 @@ m68k_option_override (void)
     }
 
 #ifndef ASM_OUTPUT_ALIGN_WITH_NOP
-  if (align_labels > 2)
+  if (GCC_OPTION (align_labels) > 2)
     {
-      warning (0, "-falign-labels=%d is not supported", align_labels);
-      align_labels = 0;
+      warning (0, "-falign-labels=%d is not supported", GCC_OPTION (align_labels));
+      GCC_OPTION (align_labels) = 0;
     }
-  if (align_loops > 2)
+  if (GCC_OPTION (align_loops) > 2)
     {
-      warning (0, "-falign-loops=%d is not supported", align_loops);
-      align_loops = 0;
+      warning (0, "-falign-loops=%d is not supported", GCC_OPTION (align_loops));
+      GCC_OPTION (align_loops) = 0;
     }
 #endif
 
@@ -639,10 +639,10 @@ m68k_option_override (void)
   else
     {
       m68k_sched_cpu = CPU_UNKNOWN;
-      flag_schedule_insns = 0;
-      flag_schedule_insns_after_reload = 0;
-      flag_modulo_sched = 0;
-      flag_live_range_shrinkage = 0;
+      GCC_OPTION (flag_schedule_insns) = 0;
+      GCC_OPTION (flag_schedule_insns_after_reload) = 0;
+      GCC_OPTION (flag_modulo_sched) = 0;
+      GCC_OPTION (flag_live_range_shrinkage) = 0;
     }
 
   if (m68k_sched_cpu != CPU_UNKNOWN)
@@ -663,10 +663,10 @@ m68k_override_options_after_change (void)
 {
   if (m68k_sched_cpu == CPU_UNKNOWN)
     {
-      flag_schedule_insns = 0;
-      flag_schedule_insns_after_reload = 0;
-      flag_modulo_sched = 0;
-      flag_live_range_shrinkage = 0;
+      GCC_OPTION (flag_schedule_insns) = 0;
+      GCC_OPTION (flag_schedule_insns_after_reload) = 0;
+      GCC_OPTION (flag_modulo_sched) = 0;
+      GCC_OPTION (flag_live_range_shrinkage) = 0;
     }
 }
 
@@ -848,7 +848,7 @@ m68k_initial_elimination_offset (int from, int to)
 static bool
 m68k_save_reg (unsigned int regno, bool interrupt_handler)
 {
-  if (flag_pic && regno == PIC_REG)
+  if (GCC_OPTION (flag_pic) && regno == PIC_REG)
     {
       if (crtl->saves_all_registers)
 	return true;
@@ -972,7 +972,7 @@ m68k_expand_prologue (void)
 
   m68k_compute_frame_layout ();
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size
       = current_frame.size + current_frame.offset;
 
@@ -1776,7 +1776,7 @@ output_btst (rtx *operands, rtx countop, rtx dataop, rtx insn, int signpos)
       /* Try to use `movew to ccr' followed by the appropriate branch insn.
          On some m68k variants unfortunately that's slower than btst.
          On 68000 and higher, that should also work for all HImode operands. */
-      if (TUNE_CPU32 || TARGET_COLDFIRE || optimize_size)
+      if (TUNE_CPU32 || TARGET_COLDFIRE || GCC_OPTION (optimize_size))
 	{
 	  if (count == 3 && DATA_REG_P (operands[1])
 	      && next_insn_tests_no_inequality (insn))
@@ -1907,7 +1907,7 @@ m68k_legitimate_constant_address_p (rtx x, unsigned int reach, bool strict_p)
   if (!CONSTANT_ADDRESS_P (x))
     return false;
 
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && !(strict_p && TARGET_PCREL)
       && symbolic_operand (x, VOIDmode))
     return false;
@@ -2179,7 +2179,7 @@ m68k_wrap_symbol (rtx x, enum m68k_reloc reloc, rtx base_reg, rtx temp_reg)
 {
   bool use_x_p;
 
-  use_x_p = (base_reg == pic_offset_table_rtx) ? TARGET_XGOT : TARGET_XTLS;
+  use_x_p = (base_reg == pic_offset_table_rtx) ? GCC_OPTION (TARGET_XGOT) : TARGET_XTLS;
 
   if (TARGET_COLDFIRE && use_x_p)
     /* When compiling with -mx{got, tls} switch the code will look like this:
@@ -4449,7 +4449,7 @@ print_operand (FILE *file, rtx op, int letter)
   else if (letter == '/')
     asm_fprintf (file, "%R");
   else if (letter == '?')
-    asm_fprintf (file, m68k_library_id_string);
+    asm_fprintf (file, GCC_OPTION (m68k_library_id_string));
   else if (letter == 'p')
     {
       output_addr_const (file, op);
@@ -4526,7 +4526,7 @@ m68k_get_reloc_decoration (enum m68k_reloc reloc)
     case RELOC_GOT:
       if (MOTOROLA)
 	{
-	  if (flag_pic == 1 && TARGET_68020)
+	  if (GCC_OPTION (flag_pic) == 1 && TARGET_68020)
 	    return "@GOT.w";
 	  else
 	    return "@GOT";
@@ -4535,7 +4535,7 @@ m68k_get_reloc_decoration (enum m68k_reloc reloc)
 	{
 	  if (TARGET_68020)
 	    {
-	      switch (flag_pic)
+	      switch (GCC_OPTION (flag_pic))
 		{
 		case 1:
 		  return ":w";
@@ -4700,7 +4700,7 @@ print_operand_address (FILE *file, rtx addr)
 	  /* (d16,PC) or (bd,PC,Xn) (with suppressed index register).  */
 	  fputc ('(', file);
 	  output_addr_const (file, addr);
-	  asm_fprintf (file, flag_pic == 1 ? ":w,%Rpc)" : ":l,%Rpc)");
+	  asm_fprintf (file, GCC_OPTION (flag_pic) == 1 ? ":w,%Rpc)" : ":l,%Rpc)");
 	}
       else
 	{
@@ -5097,7 +5097,7 @@ m68k_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
   mem = DECL_RTL (function);
   if (!sibcall_operand (XEXP (mem, 0), VOIDmode))
     {
-      gcc_assert (flag_pic);
+      gcc_assert (GCC_OPTION (flag_pic));
 
       if (!TARGET_SEP_DATA)
 	{
@@ -5124,7 +5124,7 @@ m68k_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
   reload_completed = 0;
 
   /* Restore the original PIC register.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     SET_REGNO (pic_offset_table_rtx, PIC_REG);
 }
 
@@ -6507,7 +6507,7 @@ m68k_conditional_register_usage (void)
         if (TEST_HARD_REG_BIT (x, i))
 	  fixed_regs[i] = call_used_regs[i] = 1;
     }
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     fixed_regs[PIC_REG] = call_used_regs[PIC_REG] = 1;
 }
 
diff --git a/gcc/config/m68k/m68k.h b/gcc/config/m68k/m68k.h
index 3a6d1b7..deecb13 100644
--- a/gcc/config/m68k/m68k.h
+++ b/gcc/config/m68k/m68k.h
@@ -339,7 +339,7 @@ along with GCC; see the file COPYING3.  If not see
 
 /* All m68k targets (except AmigaOS) use %a5 as the PIC register  */
 #define PIC_OFFSET_TABLE_REGNUM				\
-  (!flag_pic ? INVALID_REGNUM				\
+  (!GCC_OPTION (flag_pic) ? INVALID_REGNUM				\
    : reload_completed ? REGNO (pic_offset_table_rtx)	\
    : PIC_REG)
 
@@ -839,7 +839,7 @@ do { if (cc_prev_status.flags & CC_IN_68881)			\
    pointer for code and global references.  We still use pc-relative
    references to data, as this avoids a relocation.  */
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE, GLOBAL)			   \
-  (flag_pic								   \
+  (GCC_OPTION (flag_pic)								   \
    && !((TARGET_ID_SHARED_LIBRARY || TARGET_SEP_DATA)			   \
 	&& ((GLOBAL) || (CODE)))					   \
    ? ((GLOBAL) ? DW_EH_PE_indirect : 0) | DW_EH_PE_pcrel | DW_EH_PE_sdata4 \
diff --git a/gcc/config/m68k/netbsd-elf.h b/gcc/config/m68k/netbsd-elf.h
index be89193..4f18b28 100644
--- a/gcc/config/m68k/netbsd-elf.h
+++ b/gcc/config/m68k/netbsd-elf.h
@@ -80,7 +80,7 @@ along with GCC; see the file COPYING3.  If not see
 do									\
   {									\
     asm_fprintf (FILE, "\tlea (%LLP%d,%Rpc),%Ra1\n", (LABELNO));	\
-    if (flag_pic)							\
+    if (GCC_OPTION (flag_pic))							\
       fprintf (FILE, "\tbsr.l __mcount@PLTPC\n");			\
     else								\
       fprintf (FILE, "\tjbsr __mcount\n");				\
diff --git a/gcc/config/mcore/mcore-elf.h b/gcc/config/mcore/mcore-elf.h
index bf48d64..58aa063 100644
--- a/gcc/config/mcore/mcore-elf.h
+++ b/gcc/config/mcore/mcore-elf.h
@@ -69,7 +69,7 @@ along with GCC; see the file COPYING3.  If not see
         }							\
       ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");		\
       size_directive_output = 0;				\
-      if (!flag_inhibit_size_directive && DECL_SIZE (DECL))	\
+      if (!GCC_OPTION (flag_inhibit_size_directive) && DECL_SIZE (DECL))	\
         {							\
           size_directive_output = 1;				\
 	  size = int_size_in_bytes (TREE_TYPE (DECL));		\
@@ -90,7 +90,7 @@ along with GCC; see the file COPYING3.  If not see
     {                                                                    \
       const char * name = XSTR (XEXP (DECL_RTL (DECL), 0), 0);           \
       HOST_WIDE_INT size;						 \
-      if (!flag_inhibit_size_directive && DECL_SIZE (DECL)               \
+      if (!GCC_OPTION (flag_inhibit_size_directive) && DECL_SIZE (DECL)               \
           && ! AT_END && TOP_LEVEL                                       \
           && DECL_INITIAL (DECL) == error_mark_node                      \
           && !size_directive_output)                                     \
diff --git a/gcc/config/mcore/mcore.c b/gcc/config/mcore/mcore.c
index b2ac47e..df6738e 100644
--- a/gcc/config/mcore/mcore.c
+++ b/gcc/config/mcore/mcore.c
@@ -242,21 +242,21 @@ static void
 output_stack_adjust (int direction, int size)
 {
   /* If extending stack a lot, we do it incrementally.  */
-  if (direction < 0 && size > mcore_stack_increment && mcore_stack_increment > 0)
+  if (direction < 0 && size > GCC_OPTION (mcore_stack_increment) && GCC_OPTION (mcore_stack_increment) > 0)
     {
       rtx tmp = gen_rtx_REG (SImode, 1);
       rtx memref;
 
-      emit_insn (gen_movsi (tmp, GEN_INT (mcore_stack_increment)));
+      emit_insn (gen_movsi (tmp, GEN_INT (GCC_OPTION (mcore_stack_increment))));
       do
 	{
 	  emit_insn (gen_subsi3 (stack_pointer_rtx, stack_pointer_rtx, tmp));
 	  memref = gen_rtx_MEM (SImode, stack_pointer_rtx);
 	  MEM_VOLATILE_P (memref) = 1;
 	  emit_insn (gen_movsi (memref, stack_pointer_rtx));
-	  size -= mcore_stack_increment;
+	  size -= GCC_OPTION (mcore_stack_increment);
 	}
-      while (size > mcore_stack_increment);
+      while (size > GCC_OPTION (mcore_stack_increment));
 
       /* SIZE is now the residual for the last adjustment,
 	 which doesn't require a probe.  */
@@ -2521,7 +2521,7 @@ conditionalize_block (rtx first)
      blocks larger than size 2 (unlikely for the mcore) when speed is important.
      the best threshold depends on the latencies of the instructions (i.e., 
      the branch penalty).  */
-  if (optimize > 1 && blk_size > 2)
+  if (GCC_OPTION (optimize) > 1 && blk_size > 2)
     return insn;
 
   /* At this point, we've found the start of block 3 and we know that
@@ -2595,7 +2595,7 @@ mcore_reorg (void)
   /* Reset this variable.  */
   current_function_anonymous_args = 0;
   
-  if (optimize == 0)
+  if (GCC_OPTION (optimize) == 0)
     return;
   
   /* Conditionalize blocks where we can.  */
@@ -2678,7 +2678,7 @@ mcore_option_override (void)
 {
   /* Only the m340 supports little endian code.  */
   if (TARGET_LITTLE_END && ! TARGET_M340)
-    target_flags |= MASK_M340;
+    GCC_OPTION (target_flags) |= MASK_M340;
 }
 
 
diff --git a/gcc/config/mep/mep-pragma.c b/gcc/config/mep/mep-pragma.c
index 632e92d..82f8b0f 100644
--- a/gcc/config/mep/mep-pragma.c
+++ b/gcc/config/mep/mep-pragma.c
@@ -72,12 +72,12 @@ mep_pragma_io_volatile (cpp_reader *reader ATTRIBUTE_UNUSED)
 
       if (strcmp (str, "on") == 0)
 	{
-	  target_flags |= MASK_IO_VOLATILE;
+	  GCC_OPTION (target_flags) |= MASK_IO_VOLATILE;
 	  return;
 	}
       if (strcmp (str, "off") == 0)
 	{
-	  target_flags &= ~ MASK_IO_VOLATILE;
+	  GCC_OPTION (target_flags) &= ~ MASK_IO_VOLATILE;
 	  return;
 	}
     }
@@ -238,9 +238,9 @@ mep_pragma_coprocessor_width (void)
       /* This pragma no longer has any effect.  */
 #if 0
       if (i == 32)
-	target_flags &= ~MASK_64BIT_CR_REGS;
+	GCC_OPTION (target_flags) &= ~MASK_64BIT_CR_REGS;
       else if (i == 64)
-	target_flags |= MASK_64BIT_CR_REGS;
+	GCC_OPTION (target_flags) |= MASK_64BIT_CR_REGS;
       else
 	break;
       targetm.init_builtins ();
